/*--------------------------------------------------------------------------
 *  IncAutoSelecter Class
 *    use Prototype JavaScript framework
 *  version 0.03 + ⤦礤ʹɤ
 *  version 0.02 + KEY_UP, KEY_DOWN ٥Ƚɲ
 *
 *  2005.11.16 by http://www.drk7.jp/
 *  mailto drk7jp@gmail.com
/*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------
 * IncAutoSelecter Class 
/*--------------------------------------------------------------------------*/
var IncAutoSelecter = Class.create();
//var IncAutoSelecterShowFormChr = "(+)";
//var IncAutoSelecterHideFormChr = "(-)";
var IncAutoSelecterShowFormChr = "filter_off.gif";
var IncAutoSelecterHideFormChr = "filter_on.gif";

IncAutoSelecter.prototype = {
	// 󥹥
	/*----------------------------------------------------------------------*/
	initialize: function(select) {
		try {
			// Element ̤ʤSelectElementå
			if(select) {
				this.init(select);
			} else {
			    var nodes = document.getElementsByTagName("select");
				for( var i = 0; i < nodes.length; i++ ) {
					if(!nodes[i].getAttribute("id")) {
						nodes[i].id = nodes[i].getAttribute("name")+ "_Autoid_";
					}
					new IncAutoSelecter(nodes[i].id)
				}
			}
		} catch (e) {}
	},

	// 
	/*----------------------------------------------------------------------*/
	init: function(select) {
		// ե륿Ѥ input text ư
		new Insertion.After(select, '<div style="z-index:2; position:absolute;" id="' +select+ '_ASlayer_"><input type="text" id="' +select+ '_ASfilter_"></div>'); 
//		new Insertion.After(select, '<span id="' +select+ '_ASshowform_">' +IncAutoSelecterShowFormChr+ '</span>');
		new Insertion.After(select, '<img id="' +select+ '_ASshowform_" src="' +IncAutoSelecterShowFormChr+ '">');

		this.selectobj   = $(select);
		this.showformobj = $(select+ "_ASshowform_");
		this.layerobj    = $(select+ "_ASlayer_");
		this.filterobj   = $(select+ "_ASfilter_");

		this.filterobj.style.width = "100";
		this.filterobj.style.backgroundColor = "#e0e0e0";
		this.selectobj.style.zIndex = 1;
		this.closePopup(this.layerobj);

		this.showformobj.onclick = this.showform.bindAsEventListener(this);
		this.filterobj.onkeyup = this.selecter.bindAsEventListener(this);
	},

	// ե륿եɽ
	/*----------------------------------------------------------------------*/
	showform: function(event) {
//		if(this.showformobj.innerHTML == IncAutoSelecterShowFormChr) {
//			this.showformobj.innerHTML = IncAutoSelecterHideFormChr;
		if(String(this.showformobj.src).match(IncAutoSelecterShowFormChr)) {
			this.showformobj.src = IncAutoSelecterHideFormChr;
			Element.show(this.filterobj);

			this.openPopup(this.layerobj,event);

		} else {
//			this.showformobj.innerHTML = IncAutoSelecterShowFormChr;
			this.showformobj.src = IncAutoSelecterShowFormChr;
			Element.hide(this.filterobj);

			this.closePopup(this.layerobj);

		}
	},

	// ե륿
	/*----------------------------------------------------------------------*/
	selecter: function(event) {
		var pos=this.selectobj.selectedIndex;
		var mpos=-1;
		// key_up, key_down ٥Ƚ
		if(event.keyCode == Event.KEY_UP) {
			this.selecterUP(this);
		} else if(event.keyCode == Event.KEY_DOWN) {
			this.selecterDOWN(this);

		// Filter 
		} else {
			// Filter ̤Ϥξ̤
			if(this.filterobj.value) {
				try {
					iptval=this.filterobj.value.toLowerCase();
					for(var i=0; i<this.selectobj.length; i++) {
						var optval=this.selectobj.options[i].innerHTML.toLowerCase();
						if(String(optval).match(iptval)) {
							mpos=i;
							Element.show(this.selectobj.options[i]);
							break;
						}
					}
					// ޥåΤselectedξư
					if(mpos>-1) {
						if(pos>-1) {
							this.selectobj.options[pos].selected = false;
						}
						this.selectobj.options[mpos].selected = true;
					}
				} catch (e) { alert(pos+":"+e); }
			}
		}
	},

	// KEY_UP
	/*----------------------------------------------------------------------*/
	selecterUP: function() {
		var pos=this.selectobj.selectedIndex;
		var mpos=-1;
		// Filter ̤Ϥξ̤
		if(this.filterobj.value) {
			try {
				iptval=this.filterobj.value.toLowerCase();
				for(var i=pos-1; i>=0; i--) {
					var optval=this.selectobj.options[i].innerHTML.toLowerCase();
					if(String(optval).match(iptval)) {
						mpos=i;
						Element.show(this.selectobj.options[i]);
						break;
					}
				}
				// ޥåΤselectedξư
				if(mpos>-1) {
					if(pos>-1) {
						this.selectobj.options[pos].selected = false;
					}
					this.selectobj.options[mpos].selected = true;
				}
			} catch (e) { alert(pos+":"+e); }
		} else {
			if(pos>0) {
				this.selectobj.options[pos].selected = false;
				this.selectobj.options[pos-1].selected = true;
			} else if(pos<this.selectobj.length-1) {
				this.selectobj.options[pos].selected = false;
				this.selectobj.options[pos+1].selected = true;
			}
		}
	},

	// KEY_DOWN
	/*----------------------------------------------------------------------*/
	selecterDOWN: function() {
		var pos=this.selectobj.selectedIndex;
		var mpos=-1;
		// Filter ̤Ϥξ̤
		if(this.filterobj.value) {
			try {
				iptval=this.filterobj.value.toLowerCase();
				for(var i=pos+1; i<this.selectobj.length; i++) {
					var optval=this.selectobj.options[i].innerHTML.toLowerCase();
					if(String(optval).match(iptval)) {
						mpos=i;
						Element.show(this.selectobj.options[i]);
						break;
					}
				}
				// ޥåΤselectedξư
				if(mpos>-1) {
					if(pos>-1) {
						this.selectobj.options[pos].selected = false;
					}
					this.selectobj.options[mpos].selected = true;
				}
			} catch (e) { alert(pos+":"+e); }
		} else {
			if(pos>0) {
				this.selectobj.options[pos].selected = false;
				this.selectobj.options[pos-1].selected = true;
			} else if(pos<this.selectobj.length-1) {
				this.selectobj.options[pos].selected = false;
				this.selectobj.options[pos+1].selected = true;
			}
		}
	},

	// HTML - ݥåץå open 
	/*----------------------------------------------------------------------*/
	openPopup: function(obj_box, event) {
		var offsetx = 10;
		var offsety = 15;
		if(String(navigator.appName).match(/Netscape/)) {
			offsety = 10;
		}
		Element.show(obj_box);
		obj_box.style.left = String(Event.pointerX(event) + offsetx) + "px";
		obj_box.style.top  = String(Event.pointerY(event) - offsety) + "px";
	},

	// HTML - ݥåץå close 
	/*----------------------------------------------------------------------*/
	closePopup: function(obj_box, option) {
		Element.hide(obj_box);
	}


};


